diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -2739,1526 +1798,175 @@
         }
       return;
     }
-
-  Time txDuration = CalculateTxDuration (psdus, txVector, GetPhyBand ());
-
-  if ((m_currentEvent != 0) && (m_currentEvent->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ())))
-    {
-      //that packet will be noise _after_ the transmission.
-      MaybeCcaBusyDuration ();
-    }
-
-  if (m_currentEvent != 0)
-    {
-      AbortCurrentReception (RECEPTION_ABORTED_BY_TX);
-    }
-
-  if (m_powerRestricted)
-    {
-      NS_LOG_DEBUG ("Transmitting with power restriction");
-    }
-  else
-    {
-      NS_LOG_DEBUG ("Transmitting without power restriction");
-    }
-
-  if (m_state->GetState () == WifiPhyState::OFF)
-    {
-      NS_LOG_DEBUG ("Transmission canceled because device is OFF");
-      return;
-    }
-
-  double txPowerW = DbmToW (GetTxPowerForTransmission (txVector) + GetTxGain ());
-  NotifyTxBegin (psdus, txPowerW);
-  m_phyTxPsduBeginTrace (psdus, txVector, txPowerW);
-  for (auto const& psdu : psdus)
-    {
-      NotifyMonitorSniffTx (psdu.second, GetFrequency (), txVector, psdu.first);
-    }
-  m_state->SwitchToTx (txDuration, psdus, GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
-
-  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdus, txVector, txDuration, GetPhyBand ());
-
-  if (m_wifiRadioEnergyModel != 0 && m_wifiRadioEnergyModel->GetMaximumTimeInState (WifiPhyState::TX) < txDuration)
-    {
-      ppdu->SetTruncatedTx ();
-    }
-
-  m_endTxEvent = Simulator::Schedule (txDuration, &WifiPhy::NotifyTxEnd, this, psdus); //TODO: fix for MU
-
-  StartTx (ppdu);
-
-  m_channelAccessRequested = false;
-  m_powerRestricted = false;
-}
-
-void
-WifiPhy::StartReceiveHeader (Ptr<Event> event)
-{
-  NS_LOG_FUNCTION (this << *event);
-  NS_ASSERT (!IsStateRx ());
-  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
-  NS_ASSERT (m_currentEvent != 0);
-  NS_ASSERT (event->GetStartTime () == m_currentEvent->GetStartTime ());
-  NS_ASSERT (event->GetEndTime () == m_currentEvent->GetEndTime ());
-
-  uint16_t channelWidth;
-  if (event->GetTxVector ().GetChannelWidth () >= 40)
-    {
-      channelWidth = 20; //calculate PER on the 20 MHz primary channel for PHY headers
-    }
-  else
-    {
-      channelWidth = event->GetTxVector ().GetChannelWidth ();
-    }
-  auto band = GetBand (channelWidth);
-  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event, band);
-  double snr = snrPer.snr;
-  NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
-
-  if (!m_preambleDetectionModel || (m_preambleDetectionModel->IsPreambleDetected (event->GetRxPowerW (band), snr, m_channelWidth)))
-    {
-      NotifyRxBegin (GetAddressedPsduInPpdu (event->GetPpdu ()), event->GetRxPowerWPerBand ());
-
-      m_timeLastPreambleDetected = Simulator::Now ();
-      WifiTxVector txVector = event->GetTxVector ();
-
-      if (txVector.GetPreambleType () == WIFI_PREAMBLE_HT_GF)
-        {
-          //No non-HT PHY header for HT GF
-          Time remainingPreambleHeaderDuration = CalculatePhyPreambleAndHeaderDuration (txVector) - GetPreambleDetectionDuration ();
-          m_state->SwitchMaybeToCcaBusy (remainingPreambleHeaderDuration);
-          m_endPhyRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
-        }
-      else
-        {
-          //Schedule end of non-HT PHY header
-          Time remainingPreambleAndNonHtHeaderDuration = GetPhyPreambleDuration (txVector) + GetPhyHeaderDuration (txVector) - GetPreambleDetectionDuration ();
-          m_state->SwitchMaybeToCcaBusy (remainingPreambleAndNonHtHeaderDuration);
-          m_endPhyRxEvent = Simulator::Schedule (remainingPreambleAndNonHtHeaderDuration, &WifiPhy::ContinueReceiveHeader, this, event);
-        }
-    }
-  else
+  
+  // Set RU PHY indices
+  if (txVector.IsMu ())
     {
-      NS_LOG_DEBUG ("Drop packet because PHY preamble detection failed");
-      NotifyRxDrop (GetAddressedPsduInPpdu (event->GetPpdu ()), PREAMBLE_DETECT_FAILURE);
-      m_interference.NotifyRxEnd ();
-      m_currentEvent = 0;
-
-      // Like CCA-SD, CCA-ED is governed by the 4μs CCA window to flag CCA-BUSY
-      // for any received signal greater than the CCA-ED threshold.
-      if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
+      for (auto& heMuUserInfo : txVector.GetHeMuUserInfoMap ())
         {
-          MaybeCcaBusyDuration ();
+          heMuUserInfo.second.ru.SetPhyIndex (txVector.GetChannelWidth (),
+                                              m_operatingChannel.GetPrimaryChannelIndex (20));
         }
     }
-}
-
-void
-WifiPhy::ContinueReceiveHeader (Ptr<Event> event)
-{
-  NS_LOG_FUNCTION (this << *event);
-  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
 
-  uint16_t channelWidth;
-  if (event->GetTxVector ().GetChannelWidth () >= 40)
-    {
-      channelWidth = 20; //calculate PER on the 20 MHz primary channel for PHY headers
-    }
-  else
-    {
-      channelWidth = event->GetTxVector ().GetChannelWidth ();
-    }
-  InterferenceHelper::SnrPer snrPer = m_interference.CalculateNonHtPhyHeaderSnrPer (event, GetBand (channelWidth));
+  Time txDuration = CalculateTxDuration (psdus, txVector, GetPhyBand ());
 
-  NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
-  if (m_random->GetValue () > snrPer.per) //non-HT PHY header reception succeeded
+  bool noEndPreambleDetectionEvent = true;
+  for (const auto & it : m_phyEntities)
     {
-      NS_LOG_DEBUG ("Received non-HT PHY header");
-      WifiTxVector txVector = event->GetTxVector ();
-      Time remainingRxDuration = event->GetEndTime () - Simulator::Now ();
-      m_state->SwitchMaybeToCcaBusy (remainingRxDuration);
-      Time remainingPreambleHeaderDuration = CalculatePhyPreambleAndHeaderDuration (txVector) - GetPhyPreambleDuration (txVector) - GetPhyHeaderDuration (txVector);
-      m_endPhyRxEvent = Simulator::Schedule (remainingPreambleHeaderDuration, &WifiPhy::StartReceivePayload, this, event);
+      noEndPreambleDetectionEvent &= it.second->NoEndPreambleDetectionEvents ();
     }
-  else //non-HT PHY header reception failed
+  if (!noEndPreambleDetectionEvent || ((m_currentEvent != 0) && (m_currentEvent->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))))
     {
-      NS_LOG_DEBUG ("Abort reception because non-HT PHY header reception failed");
-      AbortCurrentReception (L_SIG_FAILURE);
-      if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          MaybeCcaBusyDuration ();
-        }
+      AbortCurrentReception (RECEPTION_ABORTED_BY_TX);
+      //that packet will be noise _after_ the transmission.
+      MaybeCcaBusyDuration (GetMeasurementChannelWidth (m_currentEvent != 0 ? m_currentEvent->GetPpdu () : nullptr));
     }
-}
-
-void
-WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW)
-{
-  //The total RX power corresponds to the maximum over all the bands
-  auto it = std::max_element (rxPowersW.begin (), rxPowersW.end (),
-    [] (const std::pair<WifiSpectrumBand, double>& p1, const std::pair<WifiSpectrumBand, double>& p2) {
-      return p1.second < p2.second;
-    });
-  NS_LOG_FUNCTION (this << *ppdu << it->second);
-  WifiTxVector txVector = ppdu->GetTxVector ();
-  Time rxDuration = ppdu->GetTxDuration ();
-  Ptr<Event> event = m_interference.Add (ppdu, txVector, rxDuration, rxPowersW);
-  Time endRx = Simulator::Now () + rxDuration;
 
-  if (m_state->GetState () == WifiPhyState::OFF)
+  for (auto & it : m_phyEntities)
     {
-      NS_LOG_DEBUG ("Cannot start RX because device is OFF");
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          MaybeCcaBusyDuration ();
-        }
-      return;
+      it.second->CancelRunningEndPreambleDetectionEvents ();
     }
+  m_currentPreambleEvents.clear ();
+  m_endPhyRxEvent.Cancel ();
 
-  if (ppdu->IsTruncatedTx ())
+  if (m_powerRestricted)
     {
-      NS_LOG_DEBUG ("Packet reception stopped because transmitter has been switched off");
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          MaybeCcaBusyDuration ();
-        }
-      return;
+      NS_LOG_DEBUG ("Transmitting with power restriction for " << txDuration.As (Time::NS));
     }
-
-  if (!txVector.GetModeInitialized ())
+  else
     {
-      //If SetRate method was not called above when filling in txVector, this means the PHY does support the rate indicated in PHY SIG headers
-      NS_LOG_DEBUG ("drop packet because of unsupported RX mode");
-      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), UNSUPPORTED_SETTINGS);
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          MaybeCcaBusyDuration ();
-        }
-      return;
+      NS_LOG_DEBUG ("Transmitting without power restriction for " << txDuration.As (Time::NS));
     }
 
-  switch (m_state->GetState ())
-    {
-    case WifiPhyState::SWITCHING:
-      NS_LOG_DEBUG ("drop packet because of channel switching");
-      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), CHANNEL_SWITCHING);
-      /*
-       * Packets received on the upcoming channel are added to the event list
-       * during the switching state. This way the medium can be correctly sensed
-       * when the device listens to the channel for the first time after the
-       * switching e.g. after channel switching, the channel may be sensed as
-       * busy due to other devices' transmissions started before the end of
-       * the switching.
-       */
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          //that packet will be noise _after_ the completion of the channel switching.
-          MaybeCcaBusyDuration ();
-        }
-      break;
-    case WifiPhyState::RX:
-      NS_ASSERT (m_currentEvent != 0);
-      if (m_frameCaptureModel != 0
-          && m_frameCaptureModel->IsInCaptureWindow (m_timeLastPreambleDetected)
-          && m_frameCaptureModel->CaptureNewFrame (m_currentEvent, event))
-        {
-          AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
-          NS_LOG_DEBUG ("Switch to new packet");
-          StartRx (event);
-        }
-      else
-        {
-          NS_LOG_DEBUG ("Drop packet because already in Rx");
-          NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), RXING);
-          if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-            {
-              //that packet will be noise _after_ the reception of the currently-received packet.
-              MaybeCcaBusyDuration ();
-            }
-        }
-      break;
-    case WifiPhyState::TX:
-      NS_LOG_DEBUG ("Drop packet because already in Tx");
-      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), TXING);
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          //that packet will be noise _after_ the transmission of the currently-transmitted packet.
-          MaybeCcaBusyDuration ();
-        }
-      break;
-    case WifiPhyState::CCA_BUSY:
-      if (m_currentEvent != 0)
-        {
-          if (m_frameCaptureModel != 0
-              && m_frameCaptureModel->IsInCaptureWindow (m_timeLastPreambleDetected)
-              && m_frameCaptureModel->CaptureNewFrame (m_currentEvent, event))
-            {
-              AbortCurrentReception (FRAME_CAPTURE_PACKET_SWITCH);
-              NS_LOG_DEBUG ("Switch to new packet");
-              StartRx (event);
-            }
-          else
-            {
-              NS_LOG_DEBUG ("Drop packet because already in Rx");
-              NotifyRxDrop (ppdu->GetPsdu (), RXING);
-              if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-                {
-                  //that packet will be noise _after_ the reception of the currently-received packet.
-                  MaybeCcaBusyDuration ();
-                }
-            }
-        }
-      else
-        {
-          StartRx (event);
-        }
-      break;
-    case WifiPhyState::IDLE:
-      StartRx (event);
-      break;
-    case WifiPhyState::SLEEP:
-      NS_LOG_DEBUG ("Drop packet because in sleep mode");
-      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), SLEEPING);
-      if (endRx > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-        {
-          //that packet will be noise _after_ the sleep period.
-          MaybeCcaBusyDuration ();
-        }
-      break;
-    default:
-      NS_FATAL_ERROR ("Invalid WifiPhy state.");
-      break;
-    }
-}
-
-void
-WifiPhy::MaybeCcaBusyDuration ()
-{
-  //We are here because we have received the first bit of a packet and we are
-  //not going to be able to synchronize on it
-  //In this model, CCA becomes busy when the aggregation of all signals as
-  //tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
-  uint16_t primaryChannelWidth = GetChannelWidth () >= 40 ? 20 : GetChannelWidth ();
-  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetBand (primaryChannelWidth));
-  if (!delayUntilCcaEnd.IsZero ())
-    {
-      m_state->SwitchMaybeToCcaBusy (delayUntilCcaEnd);
-    }
-}
-
-void
-WifiPhy::StartReceivePayload (Ptr<Event> event)
-{
-  NS_LOG_FUNCTION (this << *event);
-  NS_ASSERT (m_endPhyRxEvent.IsExpired ());
-  NS_ASSERT (m_endRxEvent.IsExpired ());
-  bool canReceivePayload = false;
-  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-  WifiModulationClass modulation = ppdu->GetModulation ();
-  //calculate PER on the primary 20 MHz channel for PHY headers
-  uint16_t primaryChannelWidth = std::min (event->GetTxVector ().GetChannelWidth (), static_cast<uint16_t> (20));
-  auto primaryBand = GetBand (primaryChannelWidth);
-  if (modulation >= WIFI_MOD_CLASS_HT)
-    {
-      InterferenceHelper::SnrPer snrPer = m_interference.CalculateHtPhyHeaderSnrPer (event, primaryBand);
-      NS_LOG_DEBUG ("snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per);
-      canReceivePayload = (m_random->GetValue () > snrPer.per);
-    }
-  else
-    {
-      //If we are here, this means non-HT PHY header was already successfully received
-      canReceivePayload = true;
-    }
-  WifiTxVector txVector = event->GetTxVector ();
-  Time payloadDuration = event->GetEndTime () - event->GetStartTime () - CalculatePhyPreambleAndHeaderDuration (txVector);
-  bool success = false;
-  if (canReceivePayload) //PHY reception succeeded
-    {
-      Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu (ppdu);
-      if (psdu)
-        {
-          WifiMode txMode = txVector.GetMode (GetStaId ());
-          uint8_t nss = txVector.GetNssMax();
-          if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
-            {
-              uint16_t staId = GetStaId ();
-              for (const auto & info : txVector.GetHeMuUserInfoMap ())
-                {
-                  if (info.first == staId)
-                    {
-                      nss = info.second.nss; //no need to look at other PSDUs
-                      break;
-                    }
-                }
-            }
-          if (nss > GetMaxSupportedRxSpatialStreams ())
-            {
-              NS_LOG_DEBUG ("Packet reception could not be started because not enough RX antennas");
-              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
-            }
-          else if ((txVector.GetChannelWidth () >= 40) && (txVector.GetChannelWidth () > GetChannelWidth ()))
-            {
-              NS_LOG_DEBUG ("Packet reception could not be started because not enough channel width");
-              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
-            }
-          else if (IsModeSupported (txMode) || IsMcsSupported (txMode))
-            {
-              m_statusPerMpdu.clear();
-              if (psdu->GetNMpdus () > 1)
-                {
-                  ScheduleEndOfMpdus (event);
-                }
-              m_state->SwitchToRx (payloadDuration);
-              m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is triggered only if headers have been correctly decoded and that the mode within is supported
-              m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::EndReceive, this, event);
-              success = true;
-              NS_LOG_DEBUG ("Receiving PSDU");
-            }
-          else //mode is not allowed
-            {
-              NS_LOG_DEBUG ("Drop packet because it was sent using an unsupported mode (" << txMode << ")");
-              NotifyRxDrop (psdu, UNSUPPORTED_SETTINGS);
-            }
-        }
-      else
-        {
-          NS_ASSERT (ppdu->IsMu ());
-          NS_LOG_DEBUG ("No PSDU addressed to that PHY in the received MU PPDU. The PPDU is filtered.");
-          payloadDuration = NanoSeconds (0); //so as to call AbortCurrentReception below
-          m_phyRxPayloadBeginTrace (txVector, payloadDuration); //this callback (equivalent to PHY-RXSTART primitive) is also triggered for filtered PPDUs
-        }
-      if (modulation == WIFI_MOD_CLASS_HE)
-        {
-          HePreambleParameters params;
-          params.rssiW = event->GetRxPowerW (primaryBand);
-          params.bssColor = event->GetTxVector ().GetBssColor ();
-          NotifyEndOfHePreamble (params);
-        }
-    }
-  else //PHY reception failed
-    {
-      NS_LOG_DEBUG ("Drop packet because HT PHY header reception failed");
-      NotifyRxDrop (GetAddressedPsduInPpdu (ppdu), SIG_A_FAILURE);
-    }
-  if (!success)
-    {
-      if (payloadDuration.IsStrictlyPositive ())
-        {
-          m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::ResetReceive, this, event);
-        }
-      else
-        {
-          AbortCurrentReception (FILTERED); //immediately followed by PHY-RXEND (Filtered)
-          if (event->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ()))
-            {
-              MaybeCcaBusyDuration ();
-            }
-        }
-    }
-}
-
-void
-WifiPhy::ScheduleEndOfMpdus (Ptr<Event> event)
-{
-  NS_LOG_FUNCTION (this << *event);
-  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-  WifiTxVector txVector = event->GetTxVector ();
-  Time endOfMpduDuration = NanoSeconds (0);
-  Time relativeStart = NanoSeconds (0);
-  Time psduDuration = ppdu->GetTxDuration () - CalculatePhyPreambleAndHeaderDuration (txVector);
-  Time remainingAmpduDuration = psduDuration;
-  MpduType mpdutype = FIRST_MPDU_IN_AGGREGATE;
-  uint32_t totalAmpduSize = 0;
-  double totalAmpduNumSymbols = 0.0;
-  Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu (ppdu);
-  size_t nMpdus = psdu->GetNMpdus ();
-  uint16_t staId = SU_STA_ID;
-  auto mpdu = psdu->begin ();
-  for (size_t i = 0; i < nMpdus && mpdu != psdu->end (); ++mpdu)
-    {
-      Time mpduDuration = GetPayloadDuration (psdu->GetAmpduSubframeSize (i), txVector,
-                                              GetPhyBand (), mpdutype, true,
-                                              totalAmpduSize, totalAmpduNumSymbols,
-                                              staId);
-
-      remainingAmpduDuration -= mpduDuration;
-      if (i == (nMpdus - 1) && !remainingAmpduDuration.IsZero ()) //no more MPDU coming
-        {
-          mpduDuration += remainingAmpduDuration; //apply a correction just in case rounding had induced slight shift
-        }
-
-      endOfMpduDuration += mpduDuration;
-      Simulator::Schedule (endOfMpduDuration, &WifiPhy::EndOfMpdu, this, event, Create<WifiPsdu> (*mpdu, false), i, relativeStart, mpduDuration);
-
-      //Prepare next iteration
-      ++i;
-      relativeStart += mpduDuration;
-      mpdutype = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
-    }
-}
-
-void
-WifiPhy::EndOfMpdu (Ptr<Event> event, Ptr<const WifiPsdu> psdu, size_t mpduIndex, Time relativeStart, Time mpduDuration)
-{
-  NS_LOG_FUNCTION (this << *event << mpduIndex << relativeStart << mpduDuration);
-  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
-  uint16_t staId = GetStaId ();
-  WifiTxVector txVector = event->GetTxVector ();
-  uint16_t channelWidth = std::min (GetChannelWidth (), txVector.GetChannelWidth ());
-  double snr = m_interference.CalculateSnr (event, channelWidth, txVector.GetNss (staId), GetBand (channelWidth));
-
-  std::pair<bool, SignalNoiseDbm> rxInfo = GetReceptionStatus (psdu, event, staId, relativeStart, mpduDuration);
-  NS_LOG_DEBUG ("Extracted MPDU #" << mpduIndex << ": duration: " << mpduDuration.GetNanoSeconds () << "ns" <<
-                ", correct reception: " << rxInfo.first << ", Signal/Noise: " << rxInfo.second.signal << "/" << rxInfo.second.noise << "dBm");
-
-  m_signalNoise = rxInfo.second;
-  m_statusPerMpdu.push_back (rxInfo.first);
-
-  if (rxInfo.first)
-    {
-      m_state->ContinueRxNextMpdu (Copy (psdu), snr, event->GetTxVector ());
-    }
-}
-
-void
-WifiPhy::EndReceive (Ptr<Event> event)
-{
-  Time psduDuration = event->GetEndTime () - event->GetStartTime ();
-  NS_LOG_FUNCTION (this << *event << psduDuration);
-  NS_ASSERT (GetLastRxEndTime () == Simulator::Now ());
-  NS_ASSERT (event->GetEndTime () == Simulator::Now ());
-
-  uint16_t staId = GetStaId ();
-  Ptr<const WifiPsdu> psdu = GetAddressedPsduInPpdu (event->GetPpdu ());
-  if (psdu->GetNMpdus () == 1)
-    {
-      //We do not enter here for A-MPDU since this is done in WifiPhy::EndOfMpdu
-      std::pair<bool, SignalNoiseDbm> rxInfo = GetReceptionStatus (psdu, event, staId, NanoSeconds (0), psduDuration);
-      m_signalNoise = rxInfo.second;
-      m_statusPerMpdu.push_back (rxInfo.first);
-    }
-
-  NotifyRxEnd (psdu);
-  WifiTxVector txVector = event->GetTxVector ();
-  uint16_t channelWidth = std::min (GetChannelWidth (), txVector.GetChannelWidth ());
-  WifiSpectrumBand band;
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
-    {
-      band = GetRuBand (txVector, staId);
-      channelWidth = HeRu::GetBandwidth (txVector.GetRu (staId).ruType);
-    }
-  else
-    {
-      band = GetBand (channelWidth);
-    }
-  double snr = m_interference.CalculateSnr (event, channelWidth, txVector.GetNss (staId), band);
-  if (std::count (m_statusPerMpdu.begin (), m_statusPerMpdu.end (), true))
-    {
-      //At least one MPDU has been successfully received
-      WifiTxVector txVector = event->GetTxVector ();
-      NotifyMonitorSniffRx (psdu, GetFrequency (), txVector, m_signalNoise, m_statusPerMpdu, staId);
-      m_state->SwitchFromRxEndOk (Copy (psdu), snr, txVector, staId, m_statusPerMpdu);
-    }
-  else
-    {
-      m_state->SwitchFromRxEndError (Copy (psdu), snr);
-    }
-
-  m_interference.NotifyRxEnd ();
-  m_currentEvent = 0;
-  MaybeCcaBusyDuration ();
-}
-
-std::pair<bool, SignalNoiseDbm>
-WifiPhy::GetReceptionStatus (Ptr<const WifiPsdu> psdu, Ptr<Event> event, uint16_t staId,
-                             Time relativeMpduStart, Time mpduDuration)
-{
-  NS_LOG_FUNCTION (this << *psdu << *event << staId << relativeMpduStart << mpduDuration);
-  uint16_t channelWidth = std::min (GetChannelWidth (), event->GetTxVector ().GetChannelWidth ());
-  WifiTxVector txVector = event->GetTxVector ();
-  WifiSpectrumBand band;
-  if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
-    {
-      band = GetRuBand (txVector, staId);
-      channelWidth = HeRu::GetBandwidth (txVector.GetRu (staId).ruType);
-    }
-  else
-    {
-      band = GetBand (channelWidth);
-    }
-  InterferenceHelper::SnrPer snrPer = m_interference.CalculatePayloadSnrPer (event, channelWidth, band, staId, std::make_pair (relativeMpduStart, relativeMpduStart + mpduDuration));
-
-  WifiMode mode = event->GetTxVector ().GetMode (staId);
-  NS_LOG_DEBUG ("mode=" << (mode.GetDataRate (event->GetTxVector (), staId)) <<
-                ", snr(dB)=" << RatioToDb (snrPer.snr) << ", per=" << snrPer.per << ", size=" << psdu->GetSize () <<
-                ", relativeStart = " << relativeMpduStart.As (Time::NS) << ", duration = " << mpduDuration.As (Time::NS));
-
-  // There are two error checks: PER and receive error model check.
-  // PER check models is typical for Wi-Fi and is based on signal modulation;
-  // Receive error model is optional, if we have an error model and
-  // it indicates that the packet is corrupt, drop the packet.
-  SignalNoiseDbm signalNoise;
-  signalNoise.signal = WToDbm (event->GetRxPowerW (band));
-  signalNoise.noise = WToDbm (event->GetRxPowerW (band) / snrPer.snr);
-  if (m_random->GetValue () > snrPer.per &&
-      !(m_postReceptionErrorModel && m_postReceptionErrorModel->IsCorrupt (psdu->GetPacket ()->Copy ())))
-    {
-      NS_LOG_DEBUG ("Reception succeeded: " << psdu);
-      return std::make_pair (true, signalNoise);
-    }
-  else
-    {
-      NS_LOG_DEBUG ("Reception failed: " << psdu);
-      return std::make_pair (false, signalNoise);
-    }
-}
-
-WifiSpectrumBand
-WifiPhy::GetRuBand (WifiTxVector txVector, uint16_t staId)
-{
-  NS_ASSERT (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU);
-  WifiSpectrumBand band;
-  HeRu::RuSpec ru = txVector.GetRu (staId);
-  uint16_t channelWidth = txVector.GetChannelWidth ();
-  NS_ASSERT (channelWidth <= GetChannelWidth ());
-  HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup (channelWidth, ru.ruType, ru.index);
-  HeRu::SubcarrierRange range = std::make_pair (group.front ().first, group.back ().second);
-  band = ConvertHeRuSubcarriers (channelWidth, range);
-  return band;
-}
-
-WifiSpectrumBand
-WifiPhy::ConvertHeRuSubcarriers (uint16_t channelWidth, HeRu::SubcarrierRange range) const
-{
-  NS_ASSERT_MSG (false, "802.11ax can only be used with SpectrumWifiPhy");
-  WifiSpectrumBand convertedSubcarriers;
-  return convertedSubcarriers;
-}
-
-void
-WifiPhy::EndReceiveInterBss (void)
-{
-  NS_LOG_FUNCTION (this);
-  if (!m_channelAccessRequested)
-    {
-      m_powerRestricted = false;
-    }
-}
-
-void
-WifiPhy::ResetReceive (Ptr<Event> event)
-{
-  NS_LOG_FUNCTION (this << *event);
-  NS_ASSERT (event->GetEndTime () == Simulator::Now ());
-  NS_ASSERT (!IsStateRx ());
-  m_interference.NotifyRxEnd ();
-  m_currentEvent = 0;
-  MaybeCcaBusyDuration ();
-}
-
-void
-WifiPhy::NotifyChannelAccessRequested (void)
-{
-  NS_LOG_FUNCTION (this);
-  m_channelAccessRequested = true;
-}
-
-// Clause 15 rates (DSSS)
-
-WifiMode
-WifiPhy::GetDsssRate1Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("DsssRate1Mbps",
-                                     WIFI_MOD_CLASS_DSSS,
-                                     true,
-                                     WIFI_CODE_RATE_UNDEFINED,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetDsssRate2Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("DsssRate2Mbps",
-                                     WIFI_MOD_CLASS_DSSS,
-                                     true,
-                                     WIFI_CODE_RATE_UNDEFINED,
-                                     4);
-  return mode;
-}
-
-
-// Clause 18 rates (HR/DSSS)
-
-WifiMode
-WifiPhy::GetDsssRate5_5Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("DsssRate5_5Mbps",
-                                     WIFI_MOD_CLASS_HR_DSSS,
-                                     true,
-                                     WIFI_CODE_RATE_UNDEFINED,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetDsssRate11Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("DsssRate11Mbps",
-                                     WIFI_MOD_CLASS_HR_DSSS,
-                                     true,
-                                     WIFI_CODE_RATE_UNDEFINED,
-                                     256);
-  return mode;
-}
-
-
-// Clause 19.5 rates (ERP-OFDM)
-
-WifiMode
-WifiPhy::GetErpOfdmRate6Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate6Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate9Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate9Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate12Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate12Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate18Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate18Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate24Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate24Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate36Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate36Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate48Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate48Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_2_3,
-                                     64);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetErpOfdmRate54Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("ErpOfdmRate54Mbps",
-                                     WIFI_MOD_CLASS_ERP_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     64);
-  return mode;
-}
-
-
-// Clause 17 rates (OFDM)
-
-WifiMode
-WifiPhy::GetOfdmRate6Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate6Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate9Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate9Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate12Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate12Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate18Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate18Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate24Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate24Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate36Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate36Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate48Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate48Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_2_3,
-                                     64);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate54Mbps ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate54Mbps",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     64);
-  return mode;
-}
-
-
-// 10 MHz channel rates
-
-WifiMode
-WifiPhy::GetOfdmRate3MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate3MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate4_5MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate4_5MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate6MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate6MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate9MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate9MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate12MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate12MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate18MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate18MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate24MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate24MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_2_3,
-                                     64);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate27MbpsBW10MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate27MbpsBW10MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     64);
-  return mode;
-}
-
-
-// 5 MHz channel rates
-
-WifiMode
-WifiPhy::GetOfdmRate1_5MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate1_5MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate2_25MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate2_25MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     2);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate3MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate3MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate4_5MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate4_5MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     4);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate6MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate6MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     true,
-                                     WIFI_CODE_RATE_1_2,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate9MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate9MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     16);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate12MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate12MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_2_3,
-                                     64);
-  return mode;
-}
-
-WifiMode
-WifiPhy::GetOfdmRate13_5MbpsBW5MHz ()
-{
-  static WifiMode mode =
-    WifiModeFactory::CreateWifiMode ("OfdmRate13_5MbpsBW5MHz",
-                                     WIFI_MOD_CLASS_OFDM,
-                                     false,
-                                     WIFI_CODE_RATE_3_4,
-                                     64);
-  return mode;
-}
-
-
-// Clause 20
-
-WifiMode
-WifiPhy::GetHtMcs0 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs0", 0, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs1 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs1", 1, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs2 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs2", 2, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs3 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs3", 3, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs4 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs4", 4, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs5 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs5", 5, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs6 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs6", 6, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs7 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs7", 7, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs8 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs8", 8, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs9 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs9", 9, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs10 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs10", 10, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs11 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs11", 11, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs12 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs12", 12, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs13 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs13", 13, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs14 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs14", 14, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs15 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs15", 15, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs16 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs16", 16, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs17 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs17", 17, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs18 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs18", 18, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs19 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs19", 19, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs20 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs20", 20, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs21 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs21", 21, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs22 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs22", 22, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs23 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs23", 23, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs24 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs24", 24, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs25 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs25", 25, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs26 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs26", 26, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs27 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs27", 27, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs28 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs28", 28, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs29 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs29", 29, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs30 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs30", 30, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetHtMcs31 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HtMcs31", 31, WIFI_MOD_CLASS_HT);
-  return mcs;
-}
-
-
-// Clause 22
-
-WifiMode
-WifiPhy::GetVhtMcs0 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs0", 0, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs1 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs1", 1, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs2 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs2", 2, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs3 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs3", 3, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs4 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs4", 4, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs5 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs5", 5, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs6 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs6", 6, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
-
-WifiMode
-WifiPhy::GetVhtMcs7 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs7", 7, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
+  if (m_state->GetState () == WifiPhyState::OFF)
+    {
+      NS_LOG_DEBUG ("Transmission canceled because device is OFF");
+      return;
+    }
 
-WifiMode
-WifiPhy::GetVhtMcs8 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs8", 8, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
+  Ptr<WifiPpdu> ppdu = GetPhyEntity (txVector.GetModulationClass ())->BuildPpdu (psdus, txVector, txDuration);
+  m_previouslyRxPpduUid = UINT64_MAX; //reset (after creation of PPDU) to use it only once
 
-WifiMode
-WifiPhy::GetVhtMcs9 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("VhtMcs9", 9, WIFI_MOD_CLASS_VHT);
-  return mcs;
-}
+  double txPowerW = DbmToW (GetTxPowerForTransmission (ppdu) + GetTxGain ());
+  NotifyTxBegin (psdus, txPowerW);
+  m_phyTxPsduBeginTrace (psdus, txVector, txPowerW);
+  for (auto const& psdu : psdus)
+    {
+      NotifyMonitorSniffTx (psdu.second, GetFrequency (), txVector, psdu.first);
+    }
+  m_state->SwitchToTx (txDuration, psdus, GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
 
-// Clause 26
+  if (m_wifiRadioEnergyModel != 0 && m_wifiRadioEnergyModel->GetMaximumTimeInState (WifiPhyState::TX) < txDuration)
+    {
+      ppdu->SetTruncatedTx ();
+    }
 
-WifiMode
-WifiPhy::GetHeMcs0 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs0", 0, WIFI_MOD_CLASS_HE);
-  return mcs;
-}
+  m_endTxEvent = Simulator::Schedule (txDuration, &WifiPhy::NotifyTxEnd, this, psdus); //TODO: fix for MU
 
-WifiMode
-WifiPhy::GetHeMcs1 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs1", 1, WIFI_MOD_CLASS_HE);
-  return mcs;
-}
+  StartTx (ppdu);
 
-WifiMode
-WifiPhy::GetHeMcs2 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs2", 2, WIFI_MOD_CLASS_HE);
-  return mcs;
-}
+  m_channelAccessRequested = false;
+  m_powerRestricted = false;
 
-WifiMode
-WifiPhy::GetHeMcs3 ()
-{
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs3", 3, WIFI_MOD_CLASS_HE);
-  return mcs;
+  Simulator::Schedule (txDuration, &WifiPhy::Reset, this);
 }
 
-WifiMode
-WifiPhy::GetHeMcs4 ()
+uint64_t
+WifiPhy::GetPreviouslyRxPpduUid (void) const
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs4", 4, WIFI_MOD_CLASS_HE);
-  return mcs;
+  return m_previouslyRxPpduUid;
 }
 
-WifiMode
-WifiPhy::GetHeMcs5 ()
+void
+WifiPhy::Reset (void)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs5", 5, WIFI_MOD_CLASS_HE);
-  return mcs;
+  NS_LOG_FUNCTION (this);
+  m_currentPreambleEvents.clear ();
+  m_currentEvent = 0;
+  for (auto & phyEntity : m_phyEntities)
+    {
+      phyEntity.second->CancelAllEvents ();
+    }
 }
 
-WifiMode
-WifiPhy::GetHeMcs6 ()
+void
+WifiPhy::StartReceivePreamble (Ptr<WifiPpdu> ppdu, RxPowerWattPerChannelBand rxPowersW, Time rxDuration)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs6", 6, WIFI_MOD_CLASS_HE);
-  return mcs;
+  WifiModulationClass modulation = ppdu->GetTxVector ().GetModulationClass ();
+  auto it = m_phyEntities.find (modulation);
+  if (it != m_phyEntities.end ())
+    {
+      it->second->StartReceivePreamble (ppdu, rxPowersW, rxDuration);
+    }
+  else
+    {
+      //TODO find a fallback PHY for receiving the PPDU (e.g. 11a for 11ax due to preamble structure)
+      NS_LOG_DEBUG ("Unsupported modulation received (" << modulation << "), consider as noise");
+      if (ppdu->GetTxDuration () > m_state->GetDelayUntilIdle ())
+        {
+          MaybeCcaBusyDuration (GetMeasurementChannelWidth (nullptr));
+        }
+    }
 }
 
-WifiMode
-WifiPhy::GetHeMcs7 ()
+void
+WifiPhy::MaybeCcaBusyDuration (uint16_t channelWidth)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs7", 7, WIFI_MOD_CLASS_HE);
-  return mcs;
+  //We are here because we have received the first bit of a packet and we are
+  //not going to be able to synchronize on it
+  //In this model, CCA becomes busy when the aggregation of all signals as
+  //tracked by the InterferenceHelper class is higher than the CcaBusyThreshold
+  Time delayUntilCcaEnd = m_interference.GetEnergyDuration (m_ccaEdThresholdW, GetPrimaryBand (channelWidth));
+  if (!delayUntilCcaEnd.IsZero ())
+    {
+      m_state->SwitchMaybeToCcaBusy (delayUntilCcaEnd);
+    }
 }
 
-WifiMode
-WifiPhy::GetHeMcs8 ()
+WifiSpectrumBand
+WifiPhy::ConvertHeRuSubcarriers (uint16_t bandWidth, uint16_t guardBandwidth,
+                                 HeRu::SubcarrierRange range, uint8_t bandIndex) const
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs8", 8, WIFI_MOD_CLASS_HE);
-  return mcs;
+  NS_ASSERT_MSG (false, "802.11ax can only be used with SpectrumWifiPhy");
+  WifiSpectrumBand convertedSubcarriers;
+  return convertedSubcarriers;
 }
 
-WifiMode
-WifiPhy::GetHeMcs9 ()
+void
+WifiPhy::EndReceiveInterBss (void)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs9", 9, WIFI_MOD_CLASS_HE);
-  return mcs;
+  NS_LOG_FUNCTION (this);
+  if (!m_channelAccessRequested)
+    {
+      m_powerRestricted = false;
+    }
 }
 
-WifiMode
-WifiPhy::GetHeMcs10 ()
+void
+WifiPhy::ResetReceive (Ptr<Event> event)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs10", 10, WIFI_MOD_CLASS_HE);
-  return mcs;
+  NS_LOG_FUNCTION (this << *event);
+  NS_ASSERT (!IsStateRx ());
+  m_interference.NotifyRxEnd (Simulator::Now ());
+  m_currentEvent = 0;
+  m_currentPreambleEvents.clear ();
+  MaybeCcaBusyDuration (GetMeasurementChannelWidth (event->GetPpdu ()));
 }
 
-WifiMode
-WifiPhy::GetHeMcs11 ()
+void
+WifiPhy::NotifyChannelAccessRequested (void)
 {
-  static WifiMode mcs =
-    WifiModeFactory::CreateWifiMcs ("HeMcs11", 11, WIFI_MOD_CLASS_HE);
-  return mcs;
+  NS_LOG_FUNCTION (this);
+  m_channelAccessRequested = true;
 }
 
 bool
 WifiPhy::IsModeSupported (WifiMode mode) const
 {
-  for (uint8_t i = 0; i < GetNModes (); i++)
+  for (const auto & phyEntity : m_phyEntities)
     {
-      if (mode == GetMode (i))
+      if (phyEntity.second->IsModeSupported (mode))
         {
           return true;
         }
